-
Payment Gateway: Integrate with Razorpay Payment Gateway.
- Other Razorpay Products: Integrate with other Razorpay products using API sample codes.
Integrate With Razorpay Payment Gateway
Start accepting domestic and international payments from customers on your website using the Razorpay Payment Gateway. Razorpay has developed the Standard Checkout method and manages it. You can configure payment methods, orders, company logo and also select custom colour based on your convenience. Razorpay supports these payment methods and international currencies. Watch this video to know how to integrate Razorpay Payment Gateway on your Python app. We recommend you check the Python Sample App, created using the video tutorial. Download the latest razorpay-python.zip file from GitHub. It is pre-compiled to include all dependencies.Handy TipsYou can also download the Razorpay Python Test App directly from github.
Project Structure
Before you begin, we recommend you check the Python Sample App, created using the video tutorial, and verify that your project contains the following files:File Name | Purpose
app.py | Contains Orders API and payment signature verification code.
index.html | Contains Checkout code.
success.html | A page to redirect users once the payment is successful. Before you proceed:- Create a Razorpay account.
- Generate the API Keys from the Dashboard. To go live with the integration and start accepting real payments, generate Live Mode API Keys and replace them in the integration.
-
Know about the Payment Flow and follow these integration steps:
- 1. Build Integration: Integrate with your Python-based website.
- 2. Test Integration: Test the integration by making a test payment.
- 3. Go-live Checklist: Check the go-live checklist.
1. Build Integration
1.1 Create an Order in Server
Order is an important step in the payment process.- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to the checkout. This ties the Order with the payment and secures the request from being tampered.
Handy TipsYou can capture payments automatically with the Payment Capture setting configuration on the Dashboard.1.1.1 Sample CodeCreate a file, for example,
app.py and add the API code given below:Request
1.1.2 Request Parameters
Here is the list of parameters for creating an order:amount mandatory
: integer Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is 299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of 7000 is to be received from the customer in two installments of #1 - 5000, #2 - 2000 then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Know more about Orders API.1.1.3 Response Parameters
Descriptions for the response parameters are present in the Orders Entity table.1.1.4 Error Response Parameters
The error response parameters are available in the API Reference Guide.1.2 Add Checkout Options
Add the Razorpay Checkout options to your project. For example, if you are using HTML for your front-end, create a page called index.html and and add the Pay button on your web page using the checkout code and either the callback URL or handler function. 1.2.1 Callback URL or Handler FunctionCallback URL | Handler Function
When you use this:- On successful payment, the customer is redirected to the specified URL, for example, a payment success page.
- On failure, the customer is asked to retry the payment. | When you use this:
- On successful payment, the customer is shown your web page.
- On failure, the customer is notified of the failure and asked to retry the payment.
1.2.2 Code to Add Pay Button
Copy-paste the parameters asoptions in your code:
Handler Function (JS) Checkout Code
Handy Tips
- If you wish to use the above code as your final code, edit the
[KEY_ID]and[KEY_SECRET]inside app.py. Use the test keys while testing your application. Know how to Generate API keys. - Test your integration using these test cards.
1.2.3 Checkout Options
key mandatory
: string API Key ID generated from the Dashboard.
amount mandatory
: integer Payment amount in the smallest currency subunit. For example, if the amount to be charged is , enter 222250 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
name mandatory
: string Your Business/Enterprise name shown on the Checkout form. For example, Acme Corp.description optional
: string Description of the purchase item shown on the Checkout form. It should start with an alphanumeric character.image optional
: string Link to an image (usually your business logo) shown on the Checkout form. Can also be a base64 string if you are not loading the image from a network.order_id mandatory
: string Order ID generated via Orders API.prefill
: object You can prefill the following details at Checkout.Boost Conversions and Minimise Drop-offs
-
Autofill customer contact details, especially phone number to ease form completion. Include customer’s phone number in the
contactparameter of the JSON request’sprefillobject. Format: +(country code)(phone number). Example: “contact”: “+919000090000”. -
This is not applicable if you do not collect customer contact details on your website before checkout, have Shopify stores or use any of the no-code apps.
nameoptional :stringCardholder’s name to be prefilled if customer is to make card payments on Checkout. For example, Gaurav Kumar.emailoptional :stringEmail address of the customer.contactoptional :stringPhone number of the customer. The expected format of the phone number is+ {country code}{phone number}. If the country code is not specified,91will be used as the default value. This is particularly important while prefillingcontactof customers with phone numbers issued outside India. Examples:- +14155552671 (a valid non-Indian number)
- +919977665544 (a valid Indian number).
If 9977665544 is entered,
+91is added to it as +919977665544.
methodoptional :stringPre-selection of the payment method for the customer. Will only work ifcontactandemailare also prefilled. Possible values:-
card -
netbanking -
wallet -
upi -
emi
notes optional
: object Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).theme
: object Thematic options to modify the appearance of Checkout.color optional
: string Enter your brand colour’s HEX code to alter the text, payment method icons and CTA (call-to-action) button colour of the Checkout form.backdrop_color optional
: string Enter a HEX code to change the Checkout’s backdrop colour.modal
: object Options to handle the Checkout modal.backdropclose optional
: boolean Indicates whether clicking the translucent blank space outside the Checkout form should close the form. Possible values:true: Closes the form when your customer clicks outside the checkout form.false(default): Does not close the form when customer clicks outside the checkout form.
escape optional
: boolean Indicates whether pressing the escape key should close the Checkout form. Possible values:true(default): Closes the form when the customer presses the escape key.false: Does not close the form when the customer presses the escape key.
handleback optional
: boolean Determines whether Checkout must behave similar to the browser when back button is pressed. Possible values:true(default): Checkout behaves similarly to the browser. That is, when the browser’s back button is pressed, the Checkout also simulates a back press. This happens as long as the Checkout modal is open.false: Checkout does not simulate a back press when browser’s back button is pressed.
confirm_close optional
: boolean Determines whether a confirmation dialog box should be shown if customers attempts to close Checkout. Possible values:true: Confirmation dialog box is shown.false(default): Confirmation dialog box is not shown.
ondismiss optional
: function Used to track the status of Checkout. You can pass a modal object with ondismiss: function()\{\} as options. This function is called when the modal is closed by the user. If retry is false, the ondismiss function is triggered when checkout closes, even after a failure.animation optional
: boolean Shows an animation before loading of Checkout. Possible values:true(default): Animation appears.false: Animation does not appear.
subscription_id optional
: string If you are accepting recurring payments using Razorpay Checkout, you should pass the relevant subscription_id to the Checkout. Know more about Subscriptions on Checkout.subscription_card_change optional
: boolean Permit or restrict customer from changing the card linked to the subscription. You can also do this from the hosted page. Possible values:true: Allow the customer to change the card from Checkout.false(default): Do not allow the customer to change the card from Checkout.
recurring optional
: boolean Determines if you are accepting recurring (charge-at-will) payments on Checkout via instruments such as emandate, paper NACH and so on. Possible values:true: You are accepting recurring payments.false(default): You are not accepting recurring payments.
callback_url optional
: string Customers will be redirected to this URL on successful payment. Ensure that the domain of the Callback URL is allowlisted.redirect optional
: boolean Determines whether to post a response to the event handler post payment completion or redirect to Callback URL. callback_url must be passed while using this parameter. Possible values:true: Customer is redirected to the specified callback URL in case of payment failure.false(default): Customer is shown the Checkout popup to retry the payment with the suggested next best option.
customer_id optional
: string Unique identifier of customer. Used for:- Local saved cards feature.
- Static bank account details on Checkout in case of Bank Transfer payment method.
remember_customer optional
: boolean Determines whether to allow saving of cards. Can also be configured via the Dashboard. Possible values:true: Enables card saving feature.false(default): Disables card saving feature.
timeout optional
: integer Sets a timeout on Checkout, in seconds. After the specified time limit, the customer will not be able to use Checkout.Handy TipsThe open method of Razorpay object (
rzp1.open()) must be invoked by your site’s JavaScript, which may or may not be a user-driven action such as a click.1.2.4 Handle Payment Success and Failure
The way the Payment Success and Failure scenarios are handled depends on the Checkout Sample Code you used in the last step. Checkout with Callback URL If you used the sample code with the callback URL: Razorpay makes a POST call to the callback URL with the razorpay_payment_id, razorpay_order_id and razorpay_signature in the response object of the successful payment. Only successful authorisations are auto-submitted. In case of failed payments, the checkout is displayed again to facilitate payment retry.Checkout with Handler Function
If you used the sample code with the handler function: The customer sees your website page. The checkout returns the response object of the successful payment (razorpay_payment_id, razorpay_order_id and razorpay_signature). Collect these and send them to your server. The customer is notified about payment failure and asked to retry the payment. Use the Success/Failure Handling code given below:Success Handling Code
1.2.5 Configure Payment Methods (Optional)
Multiple payment methods are available on Razorpay Standard Checkout.- The payment methods are fixed and cannot be changed.
- You can configure the order or make certain payment methods prominent. Know more about configuring payment methods. Know more about configuring payment methods.
1.3 Store Fields in Your Server
A successful payment returns the following fields to the Checkout form. Success Callback- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
Success Callback
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.
razorpay_order_id
: string Unique identifier for the order returned by Checkout.
razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.
1.4 Verify Payment Signature
This is a mandatory step that allows you to confirm the authenticity of the details returned to the checkout for successful payments. To verify therazorpay_signature returned to you by the checkout:
-
Create a signature in your server using the following attributes:
Attribute | Description
order_id| Retrieve theorder_idfrom your server. Do not use therazorpay_order_idreturned by checkout.razorpay_payment_id| Returned during checkout.key_secret| Available in your server. Thekey_secretthat was generated from the Dashboard. -
Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below: -
If the signature you generate on your server matches the
razorpay_signaturereturned to you by the checkout, the payment received is from an authentic source. Use the code given below to generate signature on your server:Verify Payment Signature
1.5 Verify Payment Status
Handy TipsOn the Dashboard, ensure that the payment status is Poll Payment APIs to check the payment status.
captured. Refer to the payment capture settings page to know how to capture payments automatically.You can track the payment status in three ways:To verify the payment status from the Dashboard:- Log in to the Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
Example
If you have subscribed to theorder.paid webhook event, you will receive a notification every time a customer pays you for an order.Given below is the webhook signature verification sample code.Python
2. Test Integration
After the integration is complete, a Pay button appears on your webpage/app. Click the button and make a test transaction to ensure the integration is working as expected. You can start accepting actual payments from your customers once the test transaction is successful.Netbanking
You can select any of the listed banks. After choosing a bank, Razorpay will redirect to a mock page where you can make the paymentsuccess or a failure. Since this is Test Mode, we will not redirect you to the bank login portals.
Check the list of supported banks.
UPI
You can enter one of the following UPI IDs:success@razorpay: To make the payment successful.failure@razorpay: To fail the payment.
Handy TipsYou can use Test Mode to test UPI payments, and Live Mode for UPI Intent and QR payments.
Cards
You can use the following test cards to test transactions for your integration in Test Mode.Domestic Cards
Use the following test cards for Indian payments:Network | Card Number | CVV & Expiry Date
Visa | 4100 2800 0000 1007 | Use a random CVV and any future date ^^^^^
Mastercard | 5500 6700 0000 1002 |
RuPay | 6527 6589 0000 1005 |
Diners | 3608 280009 1007 |
Amex | 3402 560004 01007 |Error Scenarios
Use these test cards to simulate payment errors. See the complete list of error test cards with detailed scenarios. Check the following lists:International Cards
Use the following test cards to test international payments. Use any valid expiration date in the future in the MM/YY format and any random CVV to create a successful payment.Card Network | Card Number | CVV & Expiry Date
Mastercard | 5555 5555 5555 4444 5105 1051 0510 5100 5104 0600 0000 0008 | Use a random CVV and any future date ^^
Visa | 4012 8888 8888 1881 | Check the list of supported card networks.Wallet
You can select any of the listed wallets. After choosing a wallet, Razorpay will redirect to a mock page where you can make the paymentsuccess or a failure. Since this is Test Mode, we will not redirect you to the wallet login portals.
Check the list of supported wallets.
3. Go-live Checklist
Check the go-live checklist for Razorpay Web Standard Checkout integration. Consider these steps before taking the integration live.3.1 Accept Live Payments
Perform an end-to-end simulation of funds flow in the Test Mode. Once confident that the integration is working as expected, switch to the Live Mode and start accepting payments from customers.3.2 Payment Capture
After payment isauthorized, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.